/*
    (C) 1995-96 AROS - The Amiga Research OS
    $Id: setioerr.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: English
*/
#include <proto/exec.h>
#include "dos_intern.h"

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH1(LONG, SetIoErr,

/*  SYNOPSIS */
	AROS_LHA(LONG, result, D1),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 77, Dos)

/*  FUNCTION
	Sets to dos error code for the current process.

    INPUTS
	result -- new error code

    RESULT
	Old error code.

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

    /* old contents */
    LONG old;

    /* Get pointer to process structure */
    struct Process *me = (struct Process *)FindTask(NULL);

    if (me->pr_Task.tc_Node.ln_Type == NT_PROCESS)
    {
	DEBUG_ACCESSOR(dprintf("SetIoErr(Proc): me = $%lx, new = %ld, old = %ld\n",
				(ULONG) me, result, me->pr_Result2));

	/* Nothing spectacular */
	old = me->pr_Result2;
	me->pr_Result2 = result;
    }
    else
    {
	DEBUG_ACCESSOR(dprintf("SetIoErr(Task): me = $%lx, new = %ld, old = %ld\n",
				(ULONG) me, result, me->pr_Task.tc_Flags && TF_ETASK ? (LONG) me->pr_Task.tc_ETask->Result2 : 0));

	/* Use ETask Result2 if available - Piru */
	if (me->pr_Task.tc_Flags && TF_ETASK)
	{
	    old = (LONG) me->pr_Task.tc_ETask->Result2;
	    me->pr_Task.tc_ETask->Result2 = (void *) result;
	}
	else
	    old = 0;
    }

    return old;

    AROS_LIBFUNC_EXIT
} /* SetIoErr */
